## nezha-boot0 1.0.1%2B11%2Bg70d35f2

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0+

#
# Makefile for sunxi bootloader
# wangwei@allwinnertech.com
#

TOPDIR=$(CURDIR)
SRCTREE=$(TOPDIR)

#Q: quit for compile
Q = @
ifeq ("$(origin V)", "command line")
VERBOSE=$(V)
endif
ifndef VERBOSE
VERBOSE=0
endif

ifeq ($(VERBOSE),1)
Q=
CMD_ECHO_SILENT := true
else
CMD_ECHO_SILENT := echo
endif

#P: platform: sun50iw3p1/sun8iw15p1 etc.
PLATFORM=NULL
ifeq ("$(origin p)", "command line")
PLATFORM=$(p)
endif

#ddr: compile module: dd3/lpddr3/ddr4/lpddr4
DRAM_TYPE=NULL
ifeq ("$(origin ddr)", "command line")
DRAM_TYPE=$(ddr)
DRAM_TYPE_NAME=_$(DRAM_TYPE)
endif

ifeq ("$(origin b)", "command line")
BOARD=$(b)
endif

CPU ?= armv7

#include config file
include $(TOPDIR)/mk/config.mk
include $(TOPDIR)/mk/checkconf.mk
include $(TOPDIR)/board/$(p)/common.mk

export Q TOPDIR SRCTREE CMD_ECHO_SILENT PLATFORM DRAM_TYPE_NAME CPU

define update-commit-info
	sh $(SRCTREE)/tools/generate_hash_header_file.sh > \
		$(SRCTREE)/include/commit_info.h.tmp
	$(call mv-if-changed,$(SRCTREE)/include/commit_info.h.tmp,$(SRCTREE)/include/commit_info.h)
endef

MAKEFLAGS += --no-print-directory

all:
	$(MAKE) boot0
	$(MAKE) fes

boot0:
ifneq ($(wildcard $(TOPDIR)/board/$(PLATFORM)/mmc.mk),)
	$(MAKE) mmc
endif
ifneq ($(wildcard $(TOPDIR)/board/$(PLATFORM)/nand.mk),)
	$(MAKE) nand
endif
ifneq ($(wildcard $(TOPDIR)/board/$(PLATFORM)/spinor.mk),)
	$(MAKE) spinor
endif

ifneq ($(wildcard $(TOPDIR)/board/$(PLATFORM)/sboot.mk),)
all: sboot
endif

fes: mkdepend
	$(MAKE) -C $(SRCTREE)/fes $@
mmc nand spinor: mkdepend
	$(MAKE) -C $(SRCTREE)/nboot $@
offline_secure_mmc offline_secure_nand offline_secure_spinor: mkdepend
	$(MAKE) -C $(SRCTREE)/nboot $@
simulate: mkdepend
	$(MAKE) -C $(SRCTREE)/nboot $@
sboot: mkdepend
	$(MAKE) -C $(SRCTREE)/sboot $@

clean:
	@find $(TOPDIR) -type f \
		\( -name 'core' -o -name '*.bak' -o -name '*~' \
		-o -name '*.o'	-o -name '*.exe' -o -name '*.axf' \
		-o -name '*.elf' \
		-o -name '*.depend' \
		-o -name '*.bin' \
		-o -name '*.log' \
		-o -name '*.map' \) \
		-exec rm {} +
	@rm -f $(TOPDIR)/fes/fes1.lds
	@rm -f $(TOPDIR)/nboot/boot0.lds
	@rm -f $(TOPDIR)/sboot/sboot.lds

distclean: clean

mkdepend:
	$(call update-commit-info)

PHONY += FORCE
FORCE:
.PHONY: $(PHONY)

=== load_image_spinor/Makefile ===
#
# (C) Copyright 2013-2016
# SPDX-License-Identifier: GPL-2.0+
#  Allwinner Technology Co., Ltd. <www.allwinnertech.com>
#
#



include $(TOPDIR)/mk/config.mk

LIB	:= $(obj)libloadspinor.o


COBJS-$(CFG_SUNXI_SPINOR) += load_image_spinor.o

SRCS	:= $(COBJS-y:.o=.c)
OBJS	:= $(addprefix $(obj),$(COBJS-y))

all:	$(obj).depend $(LIB)

$(LIB):	$(OBJS)
	$(call cmd_link_o_target, $(OBJS))

#########################################################################

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude $(obj).depend

#########################################################################

=== main/Makefile ===
# SPDX-License-Identifier: GPL-2.0+

include $(TOPDIR)/mk/config.mk

LIB	:= $(obj)libmain.o

HEAD    := boot0_head.o
ifeq ($(CFG_SUNXI_SET_SECURE_MODE),y)
MAIN   += offline_secure_main.o
else ifeq ($(CFG_SUNXI_SIMULATE_BOOT0),y)
MAIN   += simulate_main.o
else
MAIN   += boot0_main.o
endif
COBJS   += load_image.o

SRCS	:= $(MAIN:.o=.c) $(COBJS:.o=.c) $(HEAD:.o=.c)
OBJS	:= $(addprefix $(obj),$(COBJS) $(COBJS-y) $(SOBJS))
HEAD    := $(addprefix $(obj),$(HEAD))
MAIN	:= $(addprefix $(obj),$(MAIN))

all:	$(obj).depend $(HEAD) $(MAIN) $(LIB) $(DATA)

$(LIB):	$(OBJS) $(HEAD) $(MAIN)
	$(call cmd_link_o_target, $(OBJS))

#########################################################################

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude $(obj).depend

#########################################################################

## nezha-boot0 1.0.1+11+g70d35f2

=== Makefile ===
#
# (C) Copyright 2000-2011
# SPDX-License-Identifier: GPL-2.0+
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
#
# (C) Copyright 2011
# Daniel Schwierzeck, daniel.schwierzeck@googlemail.com.
#
# (C) Copyright 2011
# Texas Instruments Incorporated - http://www.ti.com/
# Aneesh V <aneesh@ti.com>
#
# See the file COPYING in the root directory of the source tree for details.
#
# Based on top-level Makefile.
#

SKIP_AUTO_CONF:=yes
NORMAL_GOALS:=mmc spinor nand
include $(TOPDIR)/mk/config.mk
include $(TOPDIR)/board/$(PLATFORM)/common.mk
ifeq ($(findstring simulate,$(MAKECMDGOALS)),simulate)
CFG_SUNXI_SIMULATE_BOOT0=y
CFG_SUNXI_SIM_SIZE_KB?=32
MAIN_OBJ=simulate_main.o
else ifeq ($(findstring $(MAKECMDGOALS),$(NORMAL_GOALS)),)
CFG_SUNXI_SET_SECURE_MODE=y
CFG_SUNXI_WATCHDOG=y
MAIN_OBJ=offline_secure_main.o
else
include $(TOPDIR)/board/$(PLATFORM)/$(MAKECMDGOALS).mk
MAIN_OBJ=boot0_main.o
endif

CPU ?= armv7

CPUDIR = $(TOPDIR)/arch/$(ARCH)/cpu/$(CPU)
BOOT0_LDSCRIPT := $(CPUDIR)/boot0.lds

# We want the final binaries in this directory
NBOOT_DIR := $(TOPDIR)/nboot/
obj := $(TOPDIR)/nboot/

LIBS-y += arch/$(ARCH)/cpu/$(CPU)/libarch.o
LIBS-y += nboot/main/libmain.o
LIBS-y += drivers/libdrivers.o
LIBS-y += common/libcommon.o
LIBS-y += board/$(PLATFORM)/libboard.o
LIBS-$(CFG_SUNXI_SET_SECURE_MODE) += drivers/secure/libsecure.o

LIBS := $(addprefix $(TOPDIR)/,$(sort $(LIBS-y)))

COBJS-y += $(TOPDIR)/nboot/main/$(MAIN_OBJ)

OBJS = $(sort $(COBJS-y))

ifndef CONFIG_BOOT0_SIZE_LIMIT
	BOOT0SIZE = $(CFG_SYS_INIT_RAM_SIZE)
else
	BOOT0SIZE = $(CFG_BOOT0_SIZE_LIMIT)
endif


# Special flags for CPP when processing the linker script.
# Pass the version down so we can handle backwards compatibility
# on the fly.
LDPPFLAGS += \
	-DBOOT0ADDR=$(CFG_BOOT0_RUN_ADDR)	 \
	-DBOOT0SIZE=$(BOOT0SIZE)	 \
	-DCPUDIR=$(CPUDIR) \
	$(shell $(LD) --version | \
	  sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')

define build_boot0_with_suffix
	$(Q)echo bootaddr is $(CFG_BOOT0_RUN_ADDR)
	$(LD) -r -o lib$(PLATFORM)$1.o $(LIBS)
	$(LD) lib$(PLATFORM)$1.o $(OBJS) $(PLATFORM_LIBGCC) $(LDFLAGS) $(LDFLAGS_GC) -Tboot0.lds -o boot0$1.elf -Map boot0$1.map
	$(OBJCOPY) $(OBJCFLAGS) -O binary  boot0$1.elf boot0$1.bin
	$(TOPDIR)/mk/gen_check_sum $(SRCTREE)/nboot/boot0$1.bin boot0$1_$(PLATFORM)$(DRAM_TYPE_NAME).bin
	$(STRIP) -g $(TOPDIR)/nboot/lib$(PLATFORM)$1.o
endef

spinor:	 $(LIBS) boot0.lds
	$(call build_boot0_with_suffix,_spinor)

mmc:	 $(LIBS) boot0.lds
	$(call build_boot0_with_suffix,_sdcard)

nand:	 $(LIBS) boot0.lds
	$(call build_boot0_with_suffix,_nand)

offline_secure_spinor:	 $(LIBS) boot0.lds $(LIBNAND)
	$(call build_boot0_with_suffix,_offline_secure)

offline_secure_mmc:	 $(LIBS) boot0.lds $(LIBNAND)
	$(call build_boot0_with_suffix,_offline_secure)

offline_secure_nand:	 $(LIBS) boot0.lds $(LIBNAND)
	$(call build_boot0_with_suffix,_offline_secure)

simulate:	 $(LIBS) boot0.lds
	$(call build_boot0_with_suffix,_simulate)

mmc_$(DRAM_TYPE):mmc
nand_$(DRAM_TYPE):nand

$(LIBS): depend
	$(MAKE) -C $(dir $(subst $(OBJTREE),,$@))

boot0.lds: $(BOOT0_LDSCRIPT) depend
	$(Q)$(CPP) $(ALL_CFLAGS) $(LDPPFLAGS) -ansi -D__ASSEMBLY__ -P - <$(BOOT0_LDSCRIPT) >$@

sinclude $(TOPDIR)/mk/target_for_conf.mk
depend: .depend build-confs
#########################################################################

# defines $(NBOOT_DIR).depend target
include $(TOPDIR)/mk/rules.mk

sinclude .depend

#########################################################################

=== main/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
#

include $(TOPDIR)/mk/config.mk

LIB	:= libmain.o

HEAD    := fes1_head.o
MAIN   += fes1_main.o

SRCS	:= $(MAIN:.o=.c) $(COBJS:.o=.c) $(HEAD:.o=.c)
OBJS	:= $(addprefix $(obj),$(COBJS) $(COBJS-y) $(SOBJS))
HEAD    := $(addprefix $(obj),$(HEAD))
MAIN	:= $(addprefix $(obj),$(MAIN))

all:	$(obj).depend $(HEAD) $(MAIN) $(LIB) $(DATA)

$(LIB):	$(OBJS) $(HEAD)
	$(call cmd_link_o_target, $(OBJS))
#########################################################################

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude $(obj).depend

#########################################################################

=== zlib/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# (C) Copyright 2000-2006
# SPDX-License-Identifier: GPL-2.0+
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.

obj-y += zlib.o

=== dram/sun20iw1p1/Makefile ===
#/*
# * Copyright 2000-2009
# SPDX-License-Identifier: GPL-2.0+
# SPDX-License-Identifier: GPL-2.0+
#  * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
#   *
#    */

include $(TOPDIR)/mk/config.mk

all:
ifeq ($(notdir $(shell find ./ -name lib-dram)), lib-dram)
	make -C lib-dram
else
	@echo "libdram exist"
endif


#########################################################################

depend:	$(obj).depend
.PHONY: depend

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

#########################################################################

=== nand/sun20iw1p1/Makefile ===
#
# (C) Copyright 2013-2016
# SPDX-License-Identifier: GPL-2.0+
#  Allwinner Technology Co., Ltd. <www.allwinnertech.com>
#
#


include $(TOPDIR)/mk/config.mk

LIB	:= $(obj)libnand.o

COBJS-y += nand/adv_NF_read.o
COBJS-y += nand/basic_nf_read.o

COBJS-y += nand_bsp/nand_for_boot0/nand_for_boot0.o  nand_bsp/nand_for_boot0/osal/nand_osal_boot0.o
COBJS-y += nand_bsp/nfc_for_boot0/src/nand_scan_for_boot.o  nand_bsp/nfc_for_boot0/src/nfc_for_boot0.o  nand_bsp/nfc_for_boot0/src/nand_simple_for_boot0.o

COBJS-$(CFG_SUNXI_SPINAND) += spinand/spic_op.o
COBJS-$(CFG_SUNXI_SPINAND) += spinand/spinand.o
COBJS-$(CFG_SUNXI_SPINAND) += spinand/spinand_basic_op.o
COBJS-$(CFG_SUNXI_SPINAND) += spinand/spinand_osal_boot0.o

COBJS	:= $(COBJS-y)
SRCS	:= $(COBJS:.o=.c)
OBJS	:= $(addprefix $(obj),$(COBJS))

all:	$(LIB)

$(LIB):	$(obj).depend $(OBJS)
	$(call cmd_link_o_target, $(OBJS))

#########################################################################

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude $(obj).depend

#########################################################################

=== dram/sun20iw1p1/lib-dram/Makefile ===
# # (C) Copyright 2013-2016
# SPDX-License-Identifier: GPL-2.0+
#  Allwinner Technology Co., Ltd. <www.allwinnertech.com>
#
#  SPDX-License-Identifier:     GPL-2.0+
#


include $(TOPDIR)/mk/config.mk

LIB	:= $(obj)libdram.o

COBJS += mctl_hal.o
# COBJS += mctl_hal.o chip_id_sd.o


COBJS	:= $(COBJS)
SRCS	:= $(COBJS:.o=.S)
OBJS	:= $(addprefix $(obj),$(COBJS))

#LIBASM  = mctl_hal.S
#asmgcc = /home/wuhuabin/workspace/tina-d1/lichee/brandy-2.0/tools/toolchain/riscv64-linux-x86_64-20200528/bin/riscv64-unknown-linux-gnu-gcc

all:	$(LIB)
#all:	$(LIB) $(LIBASM)
#	$(info "****************************************************************************")
#	$(info $(obj))
#	$(info $(SRCS))
#	$(info $(COBJS))
#	$(info "****************************************************************************")
#$(LIBASM): $(SRCS)
#	$(info "############################################################################")
#	$(info $(LIBASM))
#	$(info $(asmgcc))
#	$(info $(OBJS))
##	$(call cmd_link_o_target, $(OBJS))
#	$(asmgcc) -S -o $@ $<
#	$(info "############################################################################")
#	$(info "1111111111111111111111111111111111111111111111111111111111111111111111111111")
$(LIB):	$(obj).depend $(OBJS)
	$(call cmd_link_o_target, $(OBJS))
	#$(strip) -s libdram.o
	cp $(LIB) ../libdram

#########################################################################

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude $(obj).depend

#########################################################################

=== nand/sun20iw1p1/nand_bsp/Makefile ===
#
# (C) Copyright 2013-2016
# SPDX-License-Identifier: GPL-2.0+
#  Allwinner Technology Co., Ltd. <www.allwinnertech.com>
#
#




include $(TOPDIR)/config.mk

LIB	:= $(obj)libnand.o

COBJS += nand_for_boot0/nand_for_boot0.o  nand_for_boot0/osal/nand_osal_boot0.o

COBJS += nfc_for_boot0/src/nand_scan_for_boot.o  nfc_for_boot0/src/nfc_for_boot0.o  nfc_for_boot0/src/nand_simple_for_boot0.o


COBJS	:= $(COBJS)
SRCS	:= $(COBJS:.o=.c)
OBJS	:= $(addprefix $(obj),$(COBJS))

all:	$(LIB)

$(LIB):	$(obj).depend $(OBJS)
	$(call cmd_link_o_target, $(OBJS))

#########################################################################

# defines $(obj).depend target
include $(SRCTREE)/rules.mk

sinclude $(obj).depend

#########################################################################

=== debian/changelog ===
nezha-boot0 (1.0.1+11+g70d35f2-0ubuntu1) jammy; urgency=medium

  * Initial release (LP: #1948042)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Tue, 14 Dec 2021 12:33:39 +0100

=== debian/control ===
Source: nezha-boot0
Section: misc
Priority: optional
Maintainer: Heinrich Schuchardt <heinrich.schuchardt@canonical.com>
Build-Depends: debhelper-compat (=13),
 gcc-riscv64-linux-gnu, python3
Standards-Version: 4.5.1
Homepage: https://github.com/smaeul/sun20i_d1_spl
Vcs-Browser: https://github.com/smaeul/sun20i_d1_spl
Vcs-Git: https://github.com/smaeul/sun20i_d1_spl.git
Rules-Requires-Root: no

Package: nezha-boot0
Architecture: all
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: boot0 for Allwinner Nezha D1 board
 boot0 is based on U-Boot SPL and serves to load OpenSBI and main U-Boot.

=== debian/rules ===
#!/usr/bin/make -f

unexport LDFLAGS
unexport OBJCFLAGS

%:
	dh $@

override_dh_auto_clean:

override_dh_auto_build:
	# Always set CROSS_COMPILE, which also works for native builds.
	CROSS_COMPILE=riscv64-linux-gnu- make \
		p=sun20iw1p1 mmc

override_dh_auto_test:

override_dh_auto_install:
	find . -name boot0_sdcard_sun20iw1p1.bin

## nezha-boot0 20220228%2Bg0ad88bf

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0+

include $(TOPDIR)/mk/config.mk
LIB = libfdt.o

all: $(LIB)

include Makefile.libfdt
COBJS   += $(filter-out fdt_overlay.o,$(LIBFDT_OBJS))

SRCS	:= $(COBJS:.o=.c) $(SOBJS:.o=.S)
OBJS	:= $(addprefix $(obj),$(COBJS) $(SOBJS))

$(LIB):	$(OBJS)
	$(call cmd_link_o_target, $(OBJS))

#########################################################################

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude .depend

#########################################################################

## nezha-boot0 20220228+g0ad88bf

=== Makefile ===
#
# (C) Copyright 2000-2011
# SPDX-License-Identifier: GPL-2.0+
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
#
# (C) Copyright 2011
# Daniel Schwierzeck, daniel.schwierzeck@googlemail.com.
#
# (C) Copyright 2011
# Texas Instruments Incorporated - http://www.ti.com/
# Aneesh V <aneesh@ti.com>
#
# See the file COPYING in the root directory of the source tree for details.
#
# Based on top-level Makefile.
#

SKIP_AUTO_CONF:=yes
NORMAL_GOALS:=mmc spinor nand
include $(TOPDIR)/mk/config.mk
include $(TOPDIR)/board/$(PLATFORM)/common.mk
ifeq ($(findstring simulate,$(MAKECMDGOALS)),simulate)
CFG_SUNXI_SIMULATE_BOOT0=y
CFG_SUNXI_SIM_SIZE_KB?=32
MAIN_OBJ=simulate_main.o
else ifeq ($(findstring $(MAKECMDGOALS),$(NORMAL_GOALS)),)
CFG_SUNXI_SET_SECURE_MODE=y
CFG_SUNXI_WATCHDOG=y
MAIN_OBJ=offline_secure_main.o
else
include $(TOPDIR)/board/$(PLATFORM)/$(MAKECMDGOALS).mk
MAIN_OBJ=boot0_main.o
endif

CPU ?= armv7

CPUDIR = $(TOPDIR)/arch/$(ARCH)/cpu/$(CPU)
BOOT0_LDSCRIPT := $(CPUDIR)/boot0.lds

# We want the final binaries in this directory
NBOOT_DIR := $(TOPDIR)/nboot/
obj := $(TOPDIR)/nboot/

LIBS-y += arch/$(ARCH)/cpu/$(CPU)/libarch.o
LIBS-y += nboot/main/libmain.o
LIBS-y += drivers/libdrivers.o
LIBS-y += common/libcommon.o
LIBS-y += libfdt/libfdt.o
LIBS-y += board/$(PLATFORM)/libboard.o
LIBS-$(CFG_SUNXI_SET_SECURE_MODE) += drivers/secure/libsecure.o

LIBS := $(addprefix $(TOPDIR)/,$(sort $(LIBS-y)))

COBJS-y += $(TOPDIR)/nboot/main/$(MAIN_OBJ)

OBJS = $(sort $(COBJS-y))

ifndef CONFIG_BOOT0_SIZE_LIMIT
	BOOT0SIZE = $(CFG_SYS_INIT_RAM_SIZE)
else
	BOOT0SIZE = $(CFG_BOOT0_SIZE_LIMIT)
endif


# Special flags for CPP when processing the linker script.
# Pass the version down so we can handle backwards compatibility
# on the fly.
LDPPFLAGS += \
	-DBOOT0ADDR=$(CFG_BOOT0_RUN_ADDR)	 \
	-DBOOT0SIZE=$(BOOT0SIZE)	 \
	-DCPUDIR=$(CPUDIR) \
	$(shell $(LD) --version | \
	  sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')

define build_boot0_with_suffix
	$(Q)echo bootaddr is $(CFG_BOOT0_RUN_ADDR)
	$(LD) -r -o lib$(PLATFORM)$1.o $(LIBS)
	$(LD) lib$(PLATFORM)$1.o $(OBJS) $(PLATFORM_LIBGCC) $(LDFLAGS) $(LDFLAGS_GC) -Tboot0.lds -o boot0$1.elf -Map boot0$1.map
	$(OBJCOPY) $(OBJCFLAGS) -O binary  boot0$1.elf boot0$1.bin
	python3 $(TOPDIR)/mk/gen_check_sum $(SRCTREE)/nboot/boot0$1.bin boot0$1_$(PLATFORM)$(DRAM_TYPE_NAME).bin
	$(STRIP) -g $(TOPDIR)/nboot/lib$(PLATFORM)$1.o
endef

spinor:	 $(LIBS) boot0.lds
	$(call build_boot0_with_suffix,_spinor)

mmc:	 $(LIBS) boot0.lds
	$(call build_boot0_with_suffix,_sdcard)

nand:	 $(LIBS) boot0.lds
	$(call build_boot0_with_suffix,_nand)

offline_secure_spinor:	 $(LIBS) boot0.lds $(LIBNAND)
	$(call build_boot0_with_suffix,_offline_secure)

offline_secure_mmc:	 $(LIBS) boot0.lds $(LIBNAND)
	$(call build_boot0_with_suffix,_offline_secure)

offline_secure_nand:	 $(LIBS) boot0.lds $(LIBNAND)
	$(call build_boot0_with_suffix,_offline_secure)

simulate:	 $(LIBS) boot0.lds
	$(call build_boot0_with_suffix,_simulate)

mmc_$(DRAM_TYPE):mmc
nand_$(DRAM_TYPE):nand

$(LIBS): depend
	$(MAKE) -C $(dir $(subst $(OBJTREE),,$@))

boot0.lds: $(BOOT0_LDSCRIPT) depend
	$(Q)$(CPP) $(ALL_CFLAGS) $(LDPPFLAGS) -ansi -D__ASSEMBLY__ -P - <$(BOOT0_LDSCRIPT) >$@

sinclude $(TOPDIR)/mk/target_for_conf.mk
depend: .depend build-confs
#########################################################################

# defines $(NBOOT_DIR).depend target
include $(TOPDIR)/mk/rules.mk

sinclude .depend

#########################################################################

=== dram/Makefile ===
#
# (C) Copyright 2000-2003
# SPDX-License-Identifier: GPL-2.0+
# SPDX-License-Identifier: GPL-2.0+
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
#
# See file CREDITS for list of people who contributed to this
# project.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307 USA
#

include $(TOPDIR)/mk/config.mk

LIB	=  libdram.o

COBJS-y	+= sunxi_dram.o

ifeq ($(notdir $(shell find $(PLATFORM) -name lib-dram)),lib-dram)
LIBS-y += drivers/dram/$(PLATFORM)/libdram$(DRAM_TYPE_NAME)
else ifeq ($(CFG_FPGA_PLATFORM)$(notdir $(shell find $(PLATFORM) -name libdram-fpga)),ylibdram-fpga)
LIBS-y += drivers/dram/$(PLATFORM)/libdram-fpga$(DRAM_TYPE_NAME)
else
LIBS-y += drivers/dram/$(PLATFORM)/libdram$(DRAM_TYPE_NAME)
endif

LIBS := $(addprefix $(TOPDIR)/,$(sort $(LIBS-y)))


SRCS	:= $(COBJS-y:.o=.c)
OBJS	:= $(addprefix $(obj),$(COBJS-y))
OBJS	+= $(LIBS)
all:	$(obj).depend $(LIB)

$(LIB):	$(OBJS)
	$(call cmd_link_o_target, $(OBJS))

$(LIBS): depend
	$(MAKE) -C $(dir $(subst $(OBJTREE),,$@))
#########################################################################

depend:	$(obj).depend
.PHONY: depend

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

=== load_image_mmc/Makefile ===
#
# (C) Copyright 2013-2016
# SPDX-License-Identifier: GPL-2.0+
#  Allwinner Technology Co., Ltd. <www.allwinnertech.com>
#
#



include $(TOPDIR)/mk/config.mk

LIB	:= $(obj)libloadmmc.o

COBJS-y += load_image_sdmmc.o


SRCS	:= $(COBJS-y:.o=.c)
OBJS	:= $(addprefix $(obj),$(COBJS-y))

all:	$(obj).depend $(LIB)

$(LIB):	$(OBJS)
	$(call cmd_link_o_target, $(OBJS))

#########################################################################

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude $(obj).depend

#########################################################################

=== load_image_nand/Makefile ===
#
# (C) Copyright 2013-2016
# SPDX-License-Identifier: GPL-2.0+
#  Allwinner Technology Co., Ltd. <www.allwinnertech.com>
#
#



include $(TOPDIR)/mk/config.mk

LIB	:= $(obj)libloadnand.o

COBJS-$(CFG_SUNXI_NAND) += load_image_nand.o


SRCS	:= $(COBJS-y:.o=.c)
OBJS	:= $(addprefix $(obj),$(COBJS-y))

all:	$(obj).depend $(LIB)

$(LIB):	$(OBJS)
	$(call cmd_link_o_target, $(OBJS))

#########################################################################

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude $(obj).depend

#########################################################################

=== lzma/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# Copyright (C) 2007-2008 Industrie Dial Face S.p.A.
# SPDX-License-Identifier: GPL-2.0+
# Luigi 'Comio' Mantellini (luigi.mantellini@idf-hit.com)
#
# (C) Copyright 2003-2006
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.

ccflags-y += -D_LZMA_PROB32

obj-y += LzmaDec.o LzmaTools.o

=== power/Makefile ===
#
# Copyright (C) 2019 Allwinner.
# SPDX-License-Identifier: GPL-2.0+
# weidonghui <weidonghui@allwinnertech.com>
#
#
include $(TOPDIR)/mk/config.mk
LIB	=  libpower.o

COBJS-y += axp.o
COBJS-$(CFG_AXP809_POWER) += axp809.o
COBJS-$(CFG_AXP81X_POWER) += axp81X.o
COBJS-$(CFG_AXP858_POWER) += axp858.o
COBJS-$(CFG_AXP2101_POWER) += axp2101.o
COBJS-$(CFG_AXP2202_POWER) += axp2202.o
COBJS-$(CFG_AXP152_POWER) += axp152.o
COBJS-$(CFG_AXP1530_POWER) += axp1530.o
COBJS-$(CFG_AXP806_POWER) += axp806.o


SRCS	:= $(COBJS-y:.o=.c)
OBJS	:= $(addprefix $(obj),$(COBJS-y))

all:	$(obj).depend $(LIB)

$(LIB):	$(OBJS)
	$(call cmd_link_o_target, $(OBJS))

#########################################################################

depend:	$(obj).depend
.PHONY: depend

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

=== spinor/Makefile ===
#
# (C) Copyright 2013-2016
# SPDX-License-Identifier: GPL-2.0+
#  Allwinner Technology Co., Ltd. <www.allwinnertech.com>
#
#


include $(TOPDIR)/mk/config.mk

LIB	:= $(obj)libspinor.o

COBJS += spinor.o


COBJS	:= $(COBJS)
SRCS	:= $(COBJS:.o=.c)
OBJS	:= $(addprefix $(obj),$(COBJS))

all:	$(LIB)

$(LIB):	$(obj).depend $(OBJS)
	$(call cmd_link_o_target, $(OBJS))

#########################################################################

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude $(obj).depend

#########################################################################

=== sun20iw1p1/Makefile ===
#/*
# * Copyright 2000-2009
# SPDX-License-Identifier: GPL-2.0+
#  * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
#   *
#    */
include $(TOPDIR)/mk/config.mk
LIB	=  libboard.o


COBJS	+= board.o
COBJS	+= clock.o

SRCS	:= $(COBJS:.o=.c) $(SOBJS:.o=.S)
OBJS	:= $(addprefix $(obj),$(COBJS) $(SOBJS))

all:	 $(LIB)

$(LIB):	$(OBJS)
	$(call cmd_link_o_target, $(OBJS))

#########################################################################

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude .depend

#########################################################################

=== mmc/sun20iw1p1/Makefile ===
#
# (C) Copyright 2013-2016
# SPDX-License-Identifier: GPL-2.0+
#  Allwinner Technology Co., Ltd. <www.allwinnertech.com>
#
#


include $(TOPDIR)/mk/config.mk

LIB	:= $(obj)libmmc.o

COBJS += mmc.o
COBJS += mmc_bsp.o


COBJS	:= $(COBJS)
SRCS	:= $(COBJS:.o=.c)
OBJS	:= $(addprefix $(obj),$(COBJS))

all:	$(LIB)

$(LIB):	$(obj).depend $(OBJS)
	$(call cmd_link_o_target, $(OBJS))

#########################################################################

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude $(obj).depend

#########################################################################

=== arm/cpu/armv7/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
#

include $(TOPDIR)/mk/config.mk

LIB	:= libarch.o

START-$(CFG_SUNXI_FES) = fes1_entry.o

START-$(CFG_SUNXI_SBOOT) = sboot_entry.o

ifeq ($(CFG_SUNXI_FES)$(CFG_SUNXI_SBOOT),)
START-y = boot0_entry.o
endif

COBJS-y	+= arch_timer.o
COBJS-y   += mmu.o
SOBJS-y	+= cache-v7.o
COBJS-y   += jmp.o

ifndef CFG_SUNXI_MEMOP
SOBJS-y   += memset.o
SOBJS-y   += memcpy.o
endif

LIBS := $(addprefix $(TOPDIR)/,$(sort $(LIBS-y)))


SRCS	:= $(COBJS:.o=.c) $(SOBJS:.o=.S) $(START-y:.o=.S)
START	:= $(addprefix $(obj),$(START-y))
OBJS	:= $(addprefix $(obj),$(COBJS-y) $(SOBJS-y))
OBJS	+= $(LIBS)
all:	$(obj).depend $(START) $(LIB)


$(LIB):	$(OBJS)
	$(call cmd_link_o_target, $(OBJS))


$(LIBS): depend
	$(MAKE) -C $(dir $(subst $(OBJTREE),,$@))
#########################################################################
depend:	$(obj).depend
.PHONY: depend

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude $(obj).depend

#########################################################################

=== dram/sun20iw1p1/lib-dram/Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 
 COBJS	:= $(COBJS)
-SRCS	:= $(COBJS:.o=.S)
+SRCS	:= $(COBJS:.o=.c)
 OBJS	:= $(addprefix $(obj),$(COBJS))
 
 #LIBASM  = mctl_hal.S

=== riscv/cpu/riscv64/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
#

include $(TOPDIR)/mk/config.mk

LIB	:= libarch.o
CPU	?= riscv64

START-$(CFG_SUNXI_FES) = fes1_entry.o

START-$(CFG_SUNXI_SBOOT) = sboot_entry.o

ifeq ($(CFG_SUNXI_FES)$(CFG_SUNXI_SBOOT),)
START-y = boot0_entry.o
endif

COBJS-y	+= arch_timer.o
COBJS-y   += mmu.o
#SOBJS-y	+= cache-v7.o
COBJS-y   += jmp.o

ifndef CFG_SUNXI_MEMOP
SOBJS-y   += memset.o
SOBJS-y   += memcpy.o
endif

LIBS := $(addprefix $(TOPDIR)/,$(sort $(LIBS-y)))


SRCS	:= $(COBJS:.o=.c) $(SOBJS:.o=.S) $(START-y:.o=.S)
START	:= $(addprefix $(obj),$(START-y))
OBJS	:= $(addprefix $(obj),$(COBJS-y) $(SOBJS-y))
OBJS	+= $(LIBS)
all:	$(obj).depend $(START) $(LIB)


$(LIB):	$(OBJS)
	$(call cmd_link_o_target, $(OBJS))


$(LIBS): depend
	$(MAKE) -C $(dir $(subst $(OBJTREE),,$@))
#########################################################################
depend:	$(obj).depend
.PHONY: depend

# defines $(obj).depend target
include $(TOPDIR)/mk/rules.mk

sinclude $(obj).depend

#########################################################################

=== debian/changelog ===
nezha-boot0 (20220228+g0ad88bf-0ubuntu2~22.04.1) jammy; urgency=medium

  * Update to current upstream, commit 0ad88bfdb723
    - Provides automatic detection of RAM size (LP: #1965260)
    - d/postinst: Fix model string 'NeZha' -> 'Nezha'

 -- Alexandre Ghiti <alexandre.ghiti@canonical.com>  Mon, 20 Jun 2022 14:28:46 +0200
